#!/bin/sh
#
#  Copyright Help Ltd. 2001, 2002, 2003
#  Ivanov Arcady : arc@help0.ru
#
# X-image.sh - ,       CD-
#       "koi8-r",   CD    
#
#       images|Boot|floppies      ,
#   . 
#
#    ޣ "-f"  ţ    CD-RW   .
#
# -----------    CD-RW -----------------
#    /dev/cdwriter, /dev/sg?, /dev/scd0
#
#  LDAP:
#       cdwriter  LDAP.
#    LDAP   cdwriter  /etc/group   
#
#
typeset -i size
size=`du -cm |grep '\|total' | awk '{print $1}'`

if [ $size -gt 699 ]
then
   if [ $size -gt 799 ]
   then
      	echo ",   >= 800Mb, size="$size"Mb"
      	echo "    "
       	exit 1
    fi
	echo ",   >= 700Mb, size="$size"Mb"
	echo -n "?"
    ok="N"
    read ok
    overburn=""
    if [ "$ok" = "Y" -o $ok = "y" ]
    then
        overburn="-overburn"
        echo ",   :) "
    else
    	echo "    "
    	exit 1
    fi
fi

#
#   SCSI-
#     ,       "RW"
#     CD-RW  "RW",    
#     "cdrecord --scanbus"
#
str=`cdrecord --scanbus |grep RW`
for i in $str; do ans2=$i; break; done
if [ "$ans2" = "" ] ; then echo "CDRW         !"; exit 1; fi

echo "CD-RW SCSI lun = $ans2"

#
#      "koi8-r",   CD   koi8-r
#
str=`echo $0 | grep koi8r | wc -l`
if [ $str = 1 ]
then outputcharset="koi8-r"; echo "   CD    koi8-r"
else outputcharset="cp866" ; echo "   CD    cp866"
fi

echo "====================================="

ans1="N"
ans3="16"
ans4="N"
MSINFO=""

if [ "$1" != "-f" ] ; then

    echo -n "  ( CD-RW) [Y/N]?"
    read ans1

    if [ "$ans1" = "N" -o "$ans1" = "n" ];  then
        echo -n "    [Y/N]?"
        read ans4
    fi

    if [ "$ans4" = "Y" -o "$ans4" = "y" ] ; then
        MSINFO=`cdrecord -msinfo -dev=$ans2`
        MSINFO="-M $ans2 -C $MSINFO"
#        MSINFO="-C $MSINFO"
    fi

else
    ans1="Y"
fi

#FLAGS=" -input-charset koi8-r -output-charset $outputcharset -v -l -allow-multidot -r -T -J -U $MSINFO"
FLAGS=" -input-charset koi8-r -output-charset $outputcharset -v -l -allow-multidot -r -J -U $MSINFO"

IMAGE=/tmp/`whoami`.img

if      [ -f images/boot.img ] ; then
    mkisofs $FLAGS -b images/boot.img -o $IMAGE .
else if [ -f images/cdrom.img ] ; then
    mkisofs $FLAGS -b images/cdrom.img -o $IMAGE .
else if [ -f Boot/cdrom.img ] ; then
    mkisofs $FLAGS -b images/cdrom.img -o $IMAGE .
else if [ -f floppies/boot.flp ] ; then
    mkisofs $FLAGS -b floppies/boot.flp -o $IMAGE .
else
    mkisofs $FLAGS -T -o $IMAGE .
fi
fi
fi
fi

#    
chmod 600 $IMAGE

if [ "$ans1" = "Y" ] ; then
    cdrecord -dev=$ans2 -speed=$ans3 $overburn -v -blank=fast
fi
cdrecord -dev=$ans2 -multi -speed=$ans3  $overburn  -v $IMAGE
cdrecord -dev=$ans2 -v -eject

rm -f $IMAGE
